## lzfse 1.0

=== CMakeLists.txt ===
project(lzfse C)
cmake_minimum_required(VERSION 2.8.6)

include(CheckCCompilerFlag)

# If LZFSE is being bundled in another project, we don't want to
# install anything.  However, we want to let people override this, so
# we'll use the LZFSE_BUNDLE_MODE variable to let them do that; just
# set it to OFF in your project before you add_subdirectory(lzfse).
get_directory_property(LZFSE_PARENT_DIRECTORY PARENT_DIRECTORY)
if("${LZFSE_BUNDLE_MODE}" STREQUAL "")
  # Bundled mode hasn't been set one way or the other, set the default
  # depending on whether or not we are the top-level project.
  if(LZFSE_PARENT_DIRECTORY)
    set(LZFSE_BUNDLE_MODE ON)
  else()
    set(LZFSE_BUNDLE_MODE OFF)
  endif(LZFSE_PARENT_DIRECTORY)
endif()
mark_as_advanced(LZFSE_BUNDLE_MODE)

if(NOT LZFSE_BUNDLE_MODE)
  option(BUILD_SHARED_LIBS "Build shared libraries" ON)
else()
  set(BUILD_SHARED_LIBS OFF)
endif()

if (CMAKE_VERSION VERSION_GREATER 3.2)
  cmake_policy (SET CMP0063 NEW)
endif ()

# Compiler flags
function(lzfse_add_compiler_flags target)
  set (flags ${ARGV})
  list (REMOVE_AT flags 0)

  foreach (FLAG ${flags})
    if(CMAKE_C_COMPILER_ID STREQUAL GNU)
      # Because https://gcc.gnu.org/wiki/FAQ#wnowarning
      string(REGEX REPLACE "\\-Wno\\-(.+)" "-W\\1" flag_to_test "${FLAG}")
    else()
      set (flag_to_test ${FLAG})
    endif()

    string(REGEX REPLACE "[^a-zA-Z0-9]+" "_" test_name "CFLAG_${flag_to_test}")

    check_c_compiler_flag("${flag_to_test}" "${test_name}")
    if(${${test_name}})
      set_property(TARGET "${target}" APPEND_STRING PROPERTY COMPILE_FLAGS " ${FLAG}")
    endif()
  endforeach()
endfunction()

if (ENABLE_SANITIZER)
  set(CMAKE_C_FLAGS " ${CMAKE_C_FLAGS} -fsanitize=${ENABLE_SANITIZER}")
  set(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -fsanitize=${ENABLE_SANITIZER}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=${ENABLE_SANITIZER}")
endif ()

add_library(lzfse
  src/lzfse_decode.c
  src/lzfse_decode_base.c
  src/lzfse_encode.c
  src/lzfse_encode_base.c
  src/lzfse_fse.c
  src/lzvn_decode_base.c
  src/lzvn_encode_base.c)
lzfse_add_compiler_flags(lzfse -Wall -Wno-unknown-pragmas -Wno-unused-variable)

add_executable(lzfse_cli
  src/lzfse_main.c)
target_link_libraries(lzfse_cli lzfse)
set_target_properties(lzfse_cli PROPERTIES OUTPUT_NAME lzfse)
lzfse_add_compiler_flags(lzfse_cli -Wall -Wno-unknown-pragmas -Wno-unused-variable)

if(CMAKE_VERSION VERSION_LESS 3.1 OR CMAKE_C_COMPLIER_ID STREQUAL "Intel")
  lzfse_add_compiler_flags(lzfse -std=c99)
  lzfse_add_compiler_flags(lzfse_cli -std=c99)
else()
  set_property(TARGET lzfse PROPERTY C_STANDARD 99)
  set_property(TARGET lzfse_cli PROPERTY C_STANDARD 99)
endif()

set_target_properties(lzfse PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  C_VISIBILITY_PRESET hidden
  INTERPROCEDURAL_OPTIMIZATION TRUE)

if(BUILD_SHARED_LIBS)
  set_property(TARGET lzfse APPEND PROPERTY COMPILE_DEFINITIONS LZFSE_DLL LZFSE_DLL_EXPORTS)
  set_property(TARGET lzfse APPEND PROPERTY INTERFACE_COMPILE_DEFINITIONS LZFSE_DLL)
endif()

# Installation
if(NOT LZFSE_BUNDLE_MODE)
  include(GNUInstallDirs)

  install(TARGETS lzfse lzfse_cli
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}")
  install(FILES src/lzfse.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
endif()

# Tests

# If we're targeting Windows but not running on Windows, we need Wine
# to run the tests...
if(NOT LZFSE_DISABLE_TESTS)
  if(WIN32 AND NOT CMAKE_HOST_WIN32)
    find_program(LZFSE_WINE NAMES wine)

    if(NOT LZFSE_WINE)
      message(STATUS "wine not found, disabling tests")
      set(LZFSE_DISABLE_TESTS TRUE)
    endif()
  endif()
endif()

if(NOT LZFSE_DISABLE_TESTS)
  include(CTest)
  enable_testing()

  file(GLOB_RECURSE
    ROUNDTRIP_INPUTS
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    src/*)

  foreach(INPUT ${ROUNDTRIP_INPUTS})
    add_test(NAME "${LZFSE_TEST_PREFIX}roundtrip/${INPUT}"
      COMMAND "${CMAKE_COMMAND}"
        -DLZFSE_WRAPPER=${LZFSE_WINE}
        -DLZFSE_CLI=$<TARGET_FILE:lzfse_cli>
        -DINPUT=${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}
        -P ${CMAKE_CURRENT_SOURCE_DIR}/tests/round-trip.cmake)
  endforeach()
endif()

=== debian/changelog ===
lzfse (1.0-2) unstable; urgency=medium

  * Team upload.

  [ Tobias Heider ]
  * Update VCS links to point to salsa.debian.org
  * Fix VCS-Git format. drop branch, add .git.

  [ NoisyCoil ]
  * CMakeLists.txt: update cmake_minimum_required() (Closes: #1113259)
  * Override description-starts-with-package-name lintian error
  * d/control: set Bananas Team as Maintainer and move tobhe to Uploaders
  * d/control: bump Standards-Version to 4.7.2, no changes needed

 -- NoisyCoil <noisycoil@debian.org>  Sun, 28 Sep 2025 14:07:39 +0200

lzfse (1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1055198)

 -- Tobias Heider <me@tobhe.de>  Thu, 02 Nov 2023 09:52:21 +0100

=== debian/control ===
Source: lzfse
Section: libs
Priority: optional
Maintainer: Debian Bananas Team <team+bananas@tracker.debian.org>
Uploaders:
 Tobias Heider <me@tobhe.de>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-little-endian,
 cmake,
Standards-Version: 4.7.2
Homepage: https://github.com/lzfse/lzfse
Vcs-Browser: https://salsa.debian.org/bananas-team/lzfse
Vcs-Git: https://salsa.debian.org/bananas-team/lzfse.git
Rules-Requires-Root: no

Package: liblzfse1
Section: libs
Architecture: any
Multi-Arch: same
Breaks:
 liblzfse (<= 1.0-1),
Replaces:
 liblzfse (<= 1.0-1),
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: LZFSE Compression library
 LZFSE is a Lempel-Ziv style data compression algorithm using Finite
 State Entropy coding. It targets similar compression rates at higher
 compression and decompression speed compared to deflate using zlib.

Package: liblzfse-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 liblzfse1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 lzfse-dev (<= 1.0-1),
Replaces:
 lzfse-dev (<= 1.0-1),
Description: LZFSE Compression library (development files)
 LZFSE is a Lempel-Ziv style data compression algorithm using Finite
 State Entropy coding. It targets similar compression rates at higher
 compression and decompression speed compared to deflate using zlib.
 .
 This package contains the development files (C headers)

Package: lzfse
Section: misc
Architecture: any
Multi-Arch: foreign
Breaks:
 lzfse-bin (<= 1.0-1),
Replaces:
 lzfse-bin (<= 1.0-1),
Depends:
 liblzfse1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: LZFSE Compression library (command line tool)
 LZFSE is a Lempel-Ziv style data compression algorithm using Finite
 State Entropy coding. It targets similar compression rates at higher
 compression and decompression speed compared to deflate using zlib.
 .
 This package contains binary utilities that accompany the library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4

# GitHub hosted projects.
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/lzfse/lzfse/tags \
    (?:.*?/)lzfse-v?@ANY_VERSION@@ARCHIVE_EXT@
